The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Envelope Class Reference

STK linear line envelope class. More...

`#include <Envelope.h>`

Inheritance diagram for stk::Envelope:

## Public Member Functions
| Envelope (void)
| Default constructor.
| ~Envelope (void)
| Class destructor.
Envelope & | operator= (const Envelope &e)
| Assignment operator.
void | keyOn (StkFloat target=1.0)
| Start ramping to specified target (default = 1).
void | keyOff (StkFloat target=0.0)
| Start ramping to specified target (default = 0).
void | setRate (StkFloat rate)
| Set the rate.
void | setTime (StkFloat time)
| Set the rate based on a positive time duration (seconds).
void | setTarget (StkFloat target)
| Set the target value.
void | setValue (StkFloat value)
| Set current and target values to value.
int | getState (void) const
| Return the current envelope state (0 = at target, 1 otherwise).
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK linear line envelope class.

This class implements a simple linear line envelope generator which is capable of ramping to an arbitrary target value by a specified rate. It also responds to simple keyOn and keyOff messages, ramping to a specified target (default = 1.0) on keyOn and to a specified target (default = 0.0) on keyOff.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ setRate()

void stk::Envelope::setRate | ( | StkFloat | rate | ) |

Set the rate.

The rate must be positive (though a value of 0.0 is allowed).

## ◆ setTime()

void stk::Envelope::setTime | ( | StkFloat | time | ) |

Set the rate based on a positive time duration (seconds).

The rate is calculated such that the envelope will ramp from the current value to the current target in the specified time duration.

## ◆ tick()

StkFrames & stk::Envelope::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

113{
114#if defined(_STK_DEBUG_)
115 if ( channel >= frames.channels() ) {
116 oStream_ << "Envelope::tick(): channel and StkFrames arguments are incompatible!";
117 handleError( StkError::FUNCTION_ARGUMENT );
118 }
119#endif
120
121 StkFloat *samples = &frames[channel];
122 unsigned int hop = frames.channels();
123 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
124 *samples = tick();
125
126 return frames;
127}
stk::Envelope::tick
StkFloat tick(void)
Compute and return one output sample.
Definition Envelope.h:89
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The documentation for this class was generated from the following file:

- Envelope.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.